using System.Collections;
using System.Collections.Generic;
using UnityEngine;
using UnityEngine.UI;
using TMPro;
using Cinemachine;

public class LaunchControls : MonoBehaviour
{
    [SerializeField] private float totalThrust; //the thrust the rocket uses to launch.
    [SerializeField] private float swipeThrust; //how much thrust a swipe generates.
    [SerializeField] private float rocketThrustClamp; //makes it so that a particular rocket can only fly so high. Applied over Time.DeltaTime[?].
    [SerializeField] private float thrustDecay; //how quickly the thrust generated by swipes decreases- It'd make higher-tier rockets redundant if you could generate thrust indefinitely with any of them.
    [SerializeField] private float timeUntilLaunch; //countdown until launch.
    [SerializeField] private float magicNumber; //Ha ha, get it?
    public Rigidbody2D rocketRB; //How the force is applied to the rocket.
    private float curThrustValue; //the current thrust value. swipeThrust - thrustDecay.
    public Slider thrustGraph; //UI which denotes the thrust a rocket has.
    public TMP_Text countdownText; //Countdown.
    public TMP_Text tapsCountText;
    public HierarchyAssignment hierarchyAssignment;
    public CameraFollow cFollow;
    public DisplayScore dS;
    public int taps;
    public int tapsCount;

    public float highestPoint = 0;
    // Start is called before the first frame update
    void Start()
    {
        rocketRB.gravityScale = 0;
    }
    private void Awake()
    {
        hierarchyAssignment = FindObjectOfType<HierarchyAssignment>();
        cFollow = FindObjectOfType<CameraFollow>();
        countdownText = hierarchyAssignment.countdownText;
        tapsCountText = hierarchyAssignment.tapsCountText;
        thrustGraph = hierarchyAssignment.thrustGraph;
        //cam = hierarchyAssignment.cam;
        cFollow.GetComponent<CinemachineVirtualCamera>().Follow = transform;
        dS = FindObjectOfType<DisplayScore>();
        dS.lC = this;
        dS.atMaxHeight = true;
    }

    // Update is called once per frame
    void FixedUpdate()
    {
        swipeThrust+= magicNumber;
        if (swipeThrust > rocketThrustClamp)
        {
            swipeThrust = 100;
        }
        thrustGraph.value = swipeThrust;

        if(transform.position.y > highestPoint)
        {
            highestPoint = transform.position.y;
            countdownText.text = "" + highestPoint.ToString();
        }
        tapsCountText.text = "Tap to use fuel load \n" + tapsCount.ToString() + " fuel load(s) left";
    }


    private void Boop()
    {
        timeUntilLaunch++;
    curThrustValue = swipeThrust;
    totalThrust = curThrustValue;
        if(timeUntilLaunch > 0)
        {
            totalThrust += thrustDecay * Time.deltaTime;
        }
        taps++;
        tapsCount--;
        if(taps >= 4)
        {
            totalThrust = 0;
        }
        if(tapsCount <= 0)
        {
            tapsCount = 0;
        }
    rocketRB.velocity = new Vector2(0, totalThrust * 0.1f);
    rocketRB.gravityScale = 1;
    }

    private void Update()
    {
        if(Input.GetMouseButtonDown(0))
        {
            Boop();
            Debug.Log("Left Click was pressed");
        }
    }
}

